]> arthur.barton.de Git - netdata.git/blobdiff - charts.d/nut.chart.sh
Merge pull request #1923 from ktsaou/master
[netdata.git] / charts.d / nut.chart.sh
old mode 100755 (executable)
new mode 100644 (file)
index edb132d..6137639
@@ -1,4 +1,10 @@
-#!/bin/sh
+# no need for shebang - this file is loaded from charts.d.plugin
+
+# netdata
+# real-time performance and health monitoring, done right!
+# (C) 2016-2017 Costa Tsaousis <costa@tsaousis.gr>
+# GPL v3+
+#
 
 # a space separated list of UPS names
 # if empty, the list returned by 'upsc -l' will be used
@@ -7,26 +13,58 @@ nut_ups=
 # how frequently to collect UPS data
 nut_update_every=2
 
+# how much time in seconds, to wait for nut to respond
+nut_timeout=2
+
+# set this to 1, to enable another chart showing the number
+# of UPS clients connected to upsd
+nut_clients_chart=0
+
+# the priority of nut related to other charts
+nut_priority=90000
+
+declare -A nut_ids=()
+
+nut_get_all() {
+       run -t $nut_timeout upsc -l
+}
+
+nut_get() {
+       run -t $nut_timeout upsc "$1"
+
+       if [ "${nut_clients_chart}" -eq "1" ]
+               then
+               printf "ups.connected_clients: "
+               run -t $nut_timeout upsc -c "$1" | wc -l
+       fi
+}
+
 nut_check() {
-       local x all
+
+       # this should return:
+       #  - 0 to enable the chart
+       #  - 1 to disable the chart
+
+       local x
 
        require_cmd upsc || return 1
-       require_cmd awk  || return 1
 
-       all="$nut_ups"
-       [ -z "$all" ] && all="$(upsc -l)"
+       [ -z "$nut_ups" ] && nut_ups="$( nut_get_all )"
 
-       nut_ups=
-       for x in $all
+       for x in $nut_ups
        do
-               upsc "$x" >/dev/null
-               [ $? -eq 0 ] && nut_ups="$nut_ups $x" && continue
-               echo >&2 "nut: ERROR: Cannot get information for NUT UPS '$x'."
+               nut_get "$x" >/dev/null
+               if [ $? -eq 0 ]
+                       then
+                       nut_ids[$x]="$( fixid "$x" )"
+                       continue
+               fi
+               error "cannot get information for NUT UPS '$x'."
        done
 
-       if [ -z "$nut_ups" ]
+       if [ ${#nut_ids[@]} -eq 0 ]
                then
-               echo >&2 "nut: Please set nut_ups='ups_name' in $confd/nut.conf"
+               error "Cannot find UPSes - please set nut_ups='ups_name' in $confd/nut.conf"
                return 1
        fi
 
@@ -37,39 +75,48 @@ nut_create() {
        # create the charts
        local x
 
-       for x in $nut_ups
+       for x in "${nut_ids[@]}"
        do
                cat <<EOF
-CHART nut_$x.charge '' "UPS Charge" "percentage" $x nut area 21001 $nut_update_every
+CHART nut_$x.charge '' "UPS Charge" "percentage" ups nut.charge area $((nut_priority + 1)) $nut_update_every
 DIMENSION battery_charge charge absolute 1 100
 
-CHART nut_$x.battery_voltage '' "UPS Battery Voltage" "Volts" $x nut line 21002 $nut_update_every
+CHART nut_$x.battery_voltage '' "UPS Battery Voltage" "Volts" ups nut.battery.voltage line $((nut_priority + 2)) $nut_update_every
 DIMENSION battery_voltage voltage absolute 1 100
 DIMENSION battery_voltage_high high absolute 1 100
 DIMENSION battery_voltage_low low absolute 1 100
 DIMENSION battery_voltage_nominal nominal absolute 1 100
 
-CHART nut_$x.input_voltage '' "UPS Input Voltage" "Volts" $x nut line 21003 $nut_update_every
+CHART nut_$x.input_voltage '' "UPS Input Voltage" "Volts" input nut.input.voltage line $((nut_priority + 3)) $nut_update_every
 DIMENSION input_voltage voltage absolute 1 100
 DIMENSION input_voltage_fault fault absolute 1 100
 DIMENSION input_voltage_nominal nominal absolute 1 100
 
-CHART nut_$x.input_current '' "UPS Input Current" "Ampere" $x nut line 21004 $nut_update_every
+CHART nut_$x.input_current '' "UPS Input Current" "Ampere" input nut.input.current line $((nut_priority + 4)) $nut_update_every
 DIMENSION input_current_nominal nominal absolute 1 100
 
-CHART nut_$x.input_frequency '' "UPS Input Frequency" "Hz" $x nut line 21005 $nut_update_every
+CHART nut_$x.input_frequency '' "UPS Input Frequency" "Hz" input nut.input.frequency line $((nut_priority + 5)) $nut_update_every
 DIMENSION input_frequency frequency absolute 1 100
 DIMENSION input_frequency_nominal nominal absolute 1 100
 
-CHART nut_$x.output_voltage '' "UPS Output Voltage" "Volts" $x nut line 21006 $nut_update_every
+CHART nut_$x.output_voltage '' "UPS Output Voltage" "Volts" output nut.output.voltage line $((nut_priority + 6)) $nut_update_every
 DIMENSION output_voltage voltage absolute 1 100
 
-CHART nut_$x.load '' "UPS Load" "percentage" $x nut area 21000 $nut_update_every
+CHART nut_$x.load '' "UPS Load" "percentage" ups nut.load area $((nut_priority)) $nut_update_every
 DIMENSION load load absolute 1 100
 
-CHART nut_$x.temp '' "UPS Temperature" "temperature" $x nut line 21007 $nut_update_every
+CHART nut_$x.temp '' "UPS Temperature" "temperature" ups nut.temperature line $((nut_priority + 7)) $nut_update_every
 DIMENSION temp temp absolute 1 100
 EOF
+
+       if [ "${nut_clients_chart}" = "1" ]
+               then
+               cat <<EOF2
+CHART nut_$x.clients '' "UPS Connected Clients" "clients" ups nut.clients area $((nut_priority + 8)) $nut_update_every
+DIMENSION clients '' absolute 1 1
+EOF2
+       fi
+
        done
 
        return 0
@@ -84,11 +131,11 @@ nut_update() {
        # for each dimension
        # remember: KEEP IT SIMPLE AND SHORT
 
-       local x
-
-       for x in $nut_ups
+       local i x
+       for i in "${!nut_ids[@]}"
        do
-               upsc "$x" | awk "
+               x="${nut_ids[$i]}"
+               nut_get "$i" | awk "
 BEGIN {
        battery_charge = 0;
        battery_voltage = 0;
@@ -104,6 +151,8 @@ BEGIN {
        output_voltage = 0;
        load = 0;
        temp = 0;
+       client = 0;
+       do_clients = ${nut_clients_chart};
 }
 /^battery.charge: .*/                  { battery_charge = \$2 * 100 };
 /^battery.voltage: .*/                 { battery_voltage = \$2 * 100 };
@@ -119,6 +168,7 @@ BEGIN {
 /^output.voltage: .*/                  { output_voltage = \$2 * 100 };
 /^ups.load: .*/                                        { load = \$2 * 100 };
 /^ups.temperature: .*/                 { temp = \$2 * 100 };
+/^ups.connected_clients: .*/   { clients = \$2 };
 END {
        print \"BEGIN nut_$x.charge $1\";
        print \"SET battery_charge = \" battery_charge;
@@ -157,10 +207,16 @@ END {
        print \"BEGIN nut_$x.temp $1\";
        print \"SET temp = \" temp;
        print \"END\"
-}
-"
+
+       if(do_clients) {
+               print \"BEGIN nut_$x.clients $1\";
+               print \"SET clients = \" clients;
+               print \"END\"
+       }
+}"
+               [ $? -ne 0 ] && unset nut_ids[$i] && error "failed to get values for '$i', disabling it."
        done
-       
+
+       [ ${#nut_ids[@]} -eq 0 ] && error "no UPSes left active." && return 1
        return 0
 }
-